package com.yihu.hos.fegin;

import com.yihu.ehr.constants.ApiVersion;
import com.yihu.hos.core.constants.MicroServices;
import com.yihu.ehr.constants.ServiceApi;
import com.yihu.hos.system.model.AppApi;
import com.yihu.hos.web.framework.constant.SystemContants;
import com.yihu.hos.web.framework.model.Envelop;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.*;


@FeignClient(name = MicroServices.HosApp)
@RequestMapping(ApiVersion.Version1_0)
public interface AppApiFegin {

    @RequestMapping(value = SystemContants.AppApi.Tree, method = RequestMethod.GET)
    @ApiOperation(value = "获取过滤AppFeature列表(不分页)")
    @ResponseBody
    String tree(@RequestParam(value="appId",required = false) String appId,
                       @RequestParam(value="appName",required = false) String appName,
                       @RequestParam(value="schemaName",required = false) String schemaName);

    @RequestMapping(value = SystemContants.AppApi.GetById, method = RequestMethod.GET)
    @ResponseBody
    @ApiOperation(value = "获取appFeature")
    Envelop getById(
            @ApiParam(name = "id", value = "id")
            @PathVariable(value = "id") Integer id,
            @ApiParam(name = "schemaName", value = "schemaName")
            @RequestParam(value = "schemaName") String schemaName) throws Exception;

    @RequestMapping(value = SystemContants.AppApi.DeleteById, method = RequestMethod.DELETE)
    @ApiOperation(value = "删除AppApi")
    @ResponseBody
    Envelop delete(
            @ApiParam(name = "id", value = "id", defaultValue = "")
            @PathVariable(value = "id") Integer id,
            @RequestParam(value = "schemaName", required = false) String schemaName);

    @RequestMapping(value = SystemContants.AppApi.Create, method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_UTF8_VALUE)
    @ResponseBody
    @ApiOperation(value = "创建AppApi")
    AppApi create(
            @ApiParam(name = "json", value = "对象JSON结构体", allowMultiple = true)
            @RequestBody String json,
            @RequestParam(value = "schemaName", required = false) String schemaName) throws Exception ;

    @RequestMapping(value = ServiceApi.AppApi.AppApisNoPage, method = RequestMethod.GET)
    @ApiOperation(value = "获取过滤AppFeature列表(不分页)")
    Envelop getApiNoPage(
            @ApiParam(name = "filters", value = "过滤器，为空检索所有条件")
            @RequestParam(value = "filters", required = false) String filters,
            @RequestParam(value = "roleId", required = false) String roleId,
            @RequestParam(value = "schemaName", required = false) String schemaName) throws Exception ;
}
