package com.yihu.hos.fegin;

import com.netflix.hystrix.contrib.javanica.annotation.HystrixCommand;
import com.netflix.hystrix.contrib.javanica.annotation.HystrixProperty;
import com.yihu.ehr.constants.ApiVersion;
import com.yihu.hos.core.constants.MicroServices;
import com.yihu.hos.system.model.SystemServiceEndpoint;
import com.yihu.hos.web.framework.constant.SystemContants;
import com.yihu.hos.web.framework.model.Envelop;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.*;


@FeignClient(name = MicroServices.HosApp)
@RequestMapping(ApiVersion.Version1_0)
public interface AppServiceFegin {

    @RequestMapping(value = SystemContants.AppService.GetById, method = RequestMethod.GET)
    @ResponseBody
    @ApiOperation(value = "获取App服务")
    SystemServiceEndpoint getAppService(
            @ApiParam(name = "id", value = "id")
            @PathVariable(value = "id") String id,
            @RequestParam(value = "schemaName", required = false) String schemaName) throws Exception;

    @RequestMapping(value = SystemContants.AppService.Create, method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_UTF8_VALUE)
    @ResponseBody
    @ApiOperation(value = "创建App服务")
    @HystrixCommand(commandProperties = {
            @HystrixProperty(name = "execution.isolation.thread.timeoutInMilliseconds", value = "-1"),//超时时间
            @HystrixProperty(name = "execution.timeout.enabled", value = "false") })
    SystemServiceEndpoint create(
            @ApiParam(name = "json", value = "对象JSON结构体", allowMultiple = true)
            @RequestBody String json,
            @RequestParam(value = "schemaName", required = false) String schemaName) throws Exception ;

    @RequestMapping(value = SystemContants.AppService.Update, method = RequestMethod.PUT, consumes = MediaType.APPLICATION_JSON_UTF8_VALUE)
    @ApiOperation(value = "更新App服务")
    @ResponseBody
    SystemServiceEndpoint update(
            @ApiParam(name = "app", value = "对象JSON结构体", allowMultiple = true)
            @RequestBody String json,
            @RequestParam(value = "schemaName", required = false) String schemaName) throws Exception ;

    @RequestMapping(value = SystemContants.AppService.DeleteById, method = RequestMethod.DELETE)
    @ApiOperation(value = "删除App服务")
    @ResponseBody
    Envelop delete(
            @ApiParam(name = "id", value = "id")
            @PathVariable(value = "id") String id,
            @RequestParam(value = "schemaName", required = false) String schemaName) throws Exception;
}
